package Ukagaka::Shiori::Engine::Kawari::Kis;
use utf8;
use Ukagaka::Shiori::Engine::Kawari::Dict;
use Ukagaka::Shiori::Engine::Kawari::Dict::Value::Tree;

sub new{
	my $package = shift;
	my $dict = shift;
	my $hash = {dict => $dict};
	return bless $hash,$package;
}

sub dict{shift->{dict}}

sub entry{
	my $self = shift;
	my $key = shift;
	my $value;
	$value = $self->dict->{$key}->value(int rand $self->dict->{$key}->size() + 1) if $self->dict->{$key};
	#Ukagaka::Shiori::Engine::Kawari::Dict::Parser::parse($value);
	#while(my ($cmdstr) = $value =~ /\$\((.*?)\)/g){
	#	my ($cmd,@argv) = split / /,$cmdstr;
	#	$value =~ s/\$\($cmdstr\)/cmdexec($cmd,[@argv])/eg;
	#}
	$value =~ s/\$\{(.+?)\}/$self->entry($1)/eg;
	return $value;
}

sub setstr{
	my $self = shift;
	my $key = shift;
	my $value = shift;
	delete $self->dict->{$key};
	$self->dict->{$key} = Ukagaka::Shiori::Engine::Kawari::Dict::Value::Tree->new();
	$self->dict->{$key}->pushvalue($value);
}

1;
